; #########################################################################
.data
MainHDC			dd	0
OpenDC			dd	0
 
PixFrm			PIXELFORMATDESCRIPTOR <>
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
dFloat0		dd	0.0
dFloat1		dd	1.0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Float45 	dq 45.0
Float3 		dq 3.0
Float9 		dq 18.0
Float1 		dq 1.0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Position1 dd 0.0,0.0,-5.0
TorusRadius	dd  0.7,0.2
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
LightPosition1	dd	-1.0,0.0,2.0,0.0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
RotSpeed	dd	-0.5,0.8,-0.4
RotAngles	dd	0.1,0.5,0.0
green		dd	0.2,0.9,0.4
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
ResizeObject		PROTO	:DWORD,:DWORD
DrawScene		PROTO  
Init    		PROTO    :DWORD
CreateObjects		PROTO	:DWORD,:DWORD
RotateZYX			PROTO    :DWORD,:DWORD,:DWORD,:DWORD
Torus		PROTO    :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
CreateLight		PROTO
; #########################################################################   
 
ResizeObject		PROC	ParentW:DWORD,ParentH:DWORD
			invoke	glViewport,0,0,ParentW,ParentH
			invoke	glMatrixMode,GL_PROJECTION
			invoke	glLoadIdentity
			invoke gluPerspective,DWORD PTR Float45,DWORD PTR Float45+4,DWORD PTR Float1,DWORD PTR Float1+4,DWORD PTR Float3,DWORD PTR Float3+4,DWORD PTR Float9,DWORD PTR Float9+4
			invoke	glMatrixMode,GL_MODELVIEW
			invoke	glLoadIdentity
			ret
ResizeObject		ENDP
; #########################################################################
CreateLight    PROC
invoke	glLightfv,GL_LIGHT0,GL_POSITION,ADDR  LightPosition1
			invoke	glEnable,GL_LIGHT0


ret
CreateLight    ENDP

; #########################################################################
CreateObjects		PROC	ParentW:DWORD,ParentH:DWORD

invoke Torus,1,ADDR TorusRadius,24,24,ADDR green


invoke glMatrixMode,GL_PROJECTION
ret
CreateObjects		ENDP

; #########################################################################

DrawScene		PROC 
invoke CreateLight
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT               	

rotate 1,ADDR Position1,ADDR RotSpeed,ADDR RotAngles



		
	invoke	SwapBuffers,MainHDC
			ret
DrawScene		ENDP
; #########################################################################
Torus		PROC ListNumber:DWORD,Radius:DWORD,MaxParts:DWORD,MinParts:DWORD,Color:DWORD
LOCAL MaxStep:DWORD,MinStep:DWORD
LOCAL i:DWORD,j:DWORD
LOCAL c0:DWORD,r:DWORD,z:DWORD,b:DWORD
LOCAL a0:DWORD,a1:DWORD,x0:DWORD,x1:DWORD,y0:DWORD,y1:DWORD
LOCAL fi:DWORD,fj:DWORD
LOCAL tempX0:DWORD,tempY0:DWORD,tempX1:DWORD,tempY1:DWORD,tempZ:DWORD,tempX0c:DWORD,tempY0c:DWORD,tempX1c:DWORD,tempY1c:DWORD,zc:DWORD
.data
dva	dd	2.0

.code
invoke	glNewList,ListNumber,GL_COMPILE_AND_EXECUTE 
invoke	gluNewQuadric			
invoke glColor3fv,Color			

fldpi
fmul[dva]
fidiv[MaxParts]
fst[MaxStep]

fldpi
fmul[dva]
fidiv[MinParts]
fst[MinStep]

mov i,0
newcicle:

fild[i]
fstp[fi]

fld[MaxStep]
fmul[fi]
fst[a0]
fadd[MaxStep]
fst[a1]

fld[a0]
fcos
fst[x0]

finit

fld[a0]
fsin
fst[y0]

fld[a1]
fcos
fst[x1]

fld[a1]
fsin
fst[y1]

invoke glEnable,GL_NORMALIZE
invoke glBegin,GL_TRIANGLE_STRIP
mov j,0

@@:

fild[j]
fstp[fj]

fld[MinStep]
fmul[fj]
fst[b]

fcos
fst[c0]

mov eax,Radius
fld DWORD PTR [eax+4]
fmul[c0]

fadd DWORD PTR [eax]
fst[r]

finit

fld[b]

fsin
fst[zc]
mov eax,Radius
fmul DWORD PTR [eax+4]
fst[z]

finit
fld[x0]
fmul[r]
fst[tempX0]

fld[y0]
fmul[r]
fst[tempY0]

finit
fld[x1]
fmul[r]
fst[tempX1]

fld[y1]
fmul[r]
fst[tempY1]

finit
fld[x0]
fmul[c0]
fst[tempX0c]

fld[y0]
fmul[c0]
fst[tempY0c]

finit
fld[x1]
fmul[c0]
fst[tempX1c]

fld[y1]
fmul[c0]
fst[tempY1c]

invoke glNormal3f,DWORD PTR tempX0c,DWORD PTR tempY0c,DWORD PTR zc
invoke glVertex3f,DWORD PTR tempX0,DWORD PTR tempY0,DWORD PTR z

invoke glNormal3f,DWORD PTR tempX1c,DWORD PTR tempY1c,DWORD PTR zc
invoke glVertex3f,DWORD PTR tempX1,DWORD PTR tempY1,DWORD PTR z

inc j
mov ecx,MinParts
cmp ecx,j

jge @B

inc i
mov ecx,MaxParts
cmp ecx,i
jge newcicle

invoke glEnd
invoke glEndList
invoke glDisable,GL_NORMALIZE
ret
Torus		ENDP
; #########################################################################


Init  proc   hWn:DWORD
LOCAL	WINRect:RECT
LOCAL	PixFormat:DWORD

				invoke	GetDC,hWn
				mov	MainHDC,eax
				mov	ax,SIZEOF PixFrm
				mov	PixFrm.nSize,ax
				mov	PixFrm.nVersion,1
				mov	PixFrm.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
				mov	PixFrm.dwLayerMask,PFD_MAIN_PLANE
				mov	PixFrm.iPixelType,PFD_TYPE_RGBA
				mov	PixFrm.cColorBits,8
				mov	PixFrm.cDepthBits,16
				invoke	ChoosePixelFormat,MainHDC,ADDR PixFrm
				mov	PixFormat,eax
				invoke	SetPixelFormat,MainHDC,PixFormat,ADDR PixFrm
				cmp eax,0
                                                        je	Fail
				invoke	wglCreateContext,MainHDC
				mov	OpenDC,eax
				invoke	wglMakeCurrent,MainHDC,OpenDC
				invoke	GetClientRect,hWn,ADDR WINRect
		
				invoke	CreateObjects,WINRect.right,WINRect.bottom
			invoke glEnable,GL_TEXTURE_2D					
			invoke	glEnable,GL_DEPTH_TEST
			invoke	glShadeModel, GL_SMOOTH
			invoke	glEnable,GL_NORMALIZE
			;invoke glDepthFunc,GL_LEQUAL
			;invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST
			invoke glEnable,GL_COLOR_MATERIAL
			invoke	glEnable,GL_LIGHTING
jmp abrt
Fail:
invoke MessageBox,hWn,SADD("   "),SADD("  "),MB_OK
				
abrt:

				return	0

Init endp
; #########################################################################
RotateZYX		PROC	ListNumber:DWORD,ZYXPosition:DWORD,ZYXRotations:DWORD,ZYXAngles:DWORD
			
			mov	eax,ZYXPosition
			invoke	glTranslatef,[eax],[eax+4],[eax+8]
			mov	eax,ZYXAngles			
	    		mov	ebx,ZYXRotations
	    		fld	DWORD PTR [eax+8]
	    		fadd	DWORD PTR [ebx+8]
	    		fstp	DWORD PTR [eax+8]
	    		invoke	glRotatef,DWORD PTR [eax+8],dFloat1,dFloat1,dFloat1
	    		
	    			    		
			invoke	glCallList,ListNumber
			ret
RotateZYX		ENDP

; #########################################################################